package com.winhc.max.compute.graph.job.pagerank;

import com.aliyun.odps.graph.DefaultComputingVertexResolver;
import com.aliyun.odps.graph.Vertex;
import com.aliyun.odps.graph.VertexChanges;
import com.aliyun.odps.io.Writable;
import com.aliyun.odps.io.WritableComparable;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/6/14 09:12
 */
public class CompanyComputingVertexResolver<I extends WritableComparable, V extends Writable, E extends Writable, M extends Writable> extends DefaultComputingVertexResolver {

    @Override
    public Vertex resolveNotExistVertexMutations(WritableComparable vertexId, VertexChanges vertexChanges, boolean hasMessages) throws IOException {

        /**
         * 1. If creation of vertex desired, pick first vertex.
         */
        Vertex<I, V, E, M> vertex = addVertexIfDesired(vertexId, vertexChanges);

        /** 2. If edge addition, add the edges */
        addEdges(vertexId, vertex, vertexChanges);

        /** 3. If the vertex exists, first prune the edges. */
        removeEdges(vertexId, vertex, vertexChanges);

        /** 4. If vertex removal desired, remove the vertex. */
        vertex = removeVertexIfDesired(vertexId, vertex, vertexChanges);

        /** 5. If send messages to not exist vertex, throw exception.*/
        if (vertex == null && hasMessages) {
        }
        return vertex;
    }
}
