package com.winhc.max.compute.graph.job.pagerank;

import com.aliyun.odps.io.DoubleWritable;
import com.aliyun.odps.io.Text;
import com.aliyun.odps.io.Writable;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/6/8 09:55
 */
public class CompanyRank implements Writable {

    private Text companyName;
    private DoubleWritable initValue;
    private DoubleWritable pr;

    public static CompanyRank of(double initValue) {
        return of(new DoubleWritable(initValue));
    }

    public Text getCompanyName() {
        return companyName;
    }

    public void setCompanyName(Text companyName) {
        this.companyName = companyName;
    }

    public static CompanyRank of(DoubleWritable initValue) {
        CompanyRank companyRank = new CompanyRank();
        companyRank.initValue = initValue;
        companyRank.pr = new DoubleWritable(-1);
        return companyRank;
    }

    public DoubleWritable getFinalValue() {
        if (pr.get() < 0) {
            return initValue;
        } else {
            return new DoubleWritable(initValue.get() + pr.get());
        }
    }

    public Double getSendMsg() {
        return pr.get() < 0 ? initValue.get() : pr.get() + initValue.get();
    }

    public DoubleWritable getPr() {
        return pr.get() < 0 ? initValue : pr;
    }

    public DoubleWritable getInitValue() {
        return initValue;
    }

    public void setInitValue(DoubleWritable initValue) {
        this.initValue = initValue;
    }

    public void setPr(DoubleWritable pr) {
        this.pr = pr;
    }

    @Override
    public void write(DataOutput out) throws IOException {
        companyName.write(out);
        initValue.write(out);
        pr.write(out);
    }

    @Override
    public void readFields(DataInput in) throws IOException {
        companyName = new Text();
        initValue = new DoubleWritable();
        pr = new DoubleWritable();
        companyName.readFields(in);
        initValue.readFields(in);
        pr.readFields(in);
    }
}
