package com.winhc.max.compute.graph.job.pagerank;

import com.aliyun.odps.graph.ComputeContext;
import com.aliyun.odps.graph.Vertex;
import com.aliyun.odps.graph.WorkerContext;
import com.aliyun.odps.io.DoubleWritable;
import com.aliyun.odps.io.Text;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/6/8 10:00
 */
public class CompanyRankVertex extends
        Vertex<Text, CompanyRank, DoubleWritable, DoubleWritable> {
    @Override
    public void compute(ComputeContext<Text, CompanyRank, DoubleWritable, DoubleWritable> context, Iterable<DoubleWritable> messages) throws IOException {
        //            log.info("start -> step:" + context.getSuperstep() + ",vertex Id:" + getId() + ",vertex pr:" + getValue().get() + ";");
        Double oldPr = getValue().getPr().get();
        if (context.getSuperstep() == 0) {
//                log.info("start -> step:" + context.getSuperstep() + ",vertex Id:" + getId() + ",vertex pr:" + getValue().get() + ";");
//                setValue(new DoubleWritable(1.0));
        } else if (context.getSuperstep() >= 1) {
            double sum = 0;
            int count = 0;
            for (DoubleWritable msg : messages) {
                sum += msg.get();
                count++;
            }
            if (count > 0) {
                CompanyRank value = getValue();
                value.setPr(new DoubleWritable(0.15f + 0.85f * sum));
                setValue(value);
            }
        }

        if (hasEdges()) {
            Double sendMsg = getValue().getSendMsg();
            Double sendValue = sendMsg / getEdges().size();

            context.sendMessageToNeighbors(this, new DoubleWritable(sendValue));

            Double newPr = getValue().getPr().get();
            context.aggregate(new DoubleWritable(Math.pow(newPr - oldPr, 2)));
//                log.info("end -> step:" + context.getSuperstep() + ",vertex Id:" + getId() + ",vertex pr:" + getValue().get() + ",send message:" + sendValue);
        } else {
//                log.info("end -> step:" + context.getSuperstep() + ",vertex Id:" + getId() + ",vertex pr:" + getValue().get() + ",no send message");
        }

    }

    @Override
    public void cleanup(WorkerContext<Text, CompanyRank, DoubleWritable, DoubleWritable> context) throws IOException {
        context.write(getId(),getValue().getCompanyName(), getValue().getFinalValue(), getValue().getInitValue(), getValue().getPr());
    }
}
