package com.winhc.max.compute.graph.job.pagerank;

import com.aliyun.odps.graph.GraphLoader;
import com.aliyun.odps.graph.MutationContext;
import com.aliyun.odps.io.*;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/6/8 09:58
 */
public class CompanyRankVertexReader extends
        GraphLoader<Text, CompanyRank, DoubleWritable, DoubleWritable> {
    @Override
    public void load(LongWritable recordNum, WritableRecord record, MutationContext<Text, CompanyRank, DoubleWritable, DoubleWritable> context) throws IOException {
        CompanyRankVertex vertex = new CompanyRankVertex();

        Text companyId = (Text) record.get("investment_company_id");
        Text company_name = (Text) record.get("investment_company_name");
//        DoubleWritable initScore = ((DoubleWritable) record.get("investment_company_init_score"));
        DoubleWritable initScore = new DoubleWritable(1);
        vertex.setId(companyId);
        CompanyRank of = CompanyRank.of(initScore);
        of.setCompanyName(company_name);
        vertex.setValue(of);
        Writable holder_info = record.get("holder_info");

        if (!(holder_info.equals(NullWritable.get()))) {
            String[] split1 = holder_info.toString().split(",");
            for (String s : split1) {
                String[] split = s.split("=");
                vertex.addEdge(new Text(split[0]), new DoubleWritable(1 / split1.length));
            }
        }
//            log.info(graphId.toString() + "," + holder_info.toString() + " vertex edgs size: " + (vertex.hasEdges() ? vertex.getEdges().size() : 0));
        context.addVertexRequest(vertex);
    }
}
